"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const dependency_path_1 = require("dependency-path");
const fromPairs_1 = __importDefault(require("ramda/src/fromPairs"));
function extendProjectsWithTargetDirs(projects, lockfile, ctx) {
    var _a;
    const getLocalLocation = ctx.pkgLocationByDepPath != null
        ? (depPath) => ctx.pkgLocationByDepPath[depPath]
        : (depPath, pkgName) => path_1.default.join(ctx.virtualStoreDir, (0, dependency_path_1.depPathToFilename)(depPath, ctx.lockfileDir), 'node_modules', pkgName);
    const projectsById = (0, fromPairs_1.default)(projects.map((project) => [project.id, { ...project, targetDirs: [] }]));
    Object.entries((_a = lockfile.packages) !== null && _a !== void 0 ? _a : {})
        .forEach(([depPath, pkg]) => {
        var _a, _b;
        if (((_a = pkg.resolution) === null || _a === void 0 ? void 0 : _a['type']) !== 'directory')
            return;
        const pkgId = (_b = pkg.id) !== null && _b !== void 0 ? _b : depPath;
        const importerId = pkgId.replace(/^file:/, '');
        if (projectsById[importerId] == null)
            return;
        const localLocation = getLocalLocation(depPath, pkg.name);
        projectsById[importerId].targetDirs.push(localLocation);
        projectsById[importerId].stages = ['preinstall', 'install', 'postinstall', 'prepare', 'prepublishOnly'];
    });
    return Object.values(projectsById);
}
exports.default = extendProjectsWithTargetDirs;
//# sourceMappingURL=extendProjectsWithTargetDirs.js.map